//+------------------------------------------------------------------+
//|                                                  Corellation.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow
extern int       per=1024;
extern double    k1=-1;
extern double    k2=1;
static string sy[28]={"AUDCAD","AUDCHF","EURAUD","GBPAUD","AUDJPY","AUDNZD","AUDUSD",
                      "CADCHF","EURCAD","GBPCAD","CADJPY","NZDCAD","USDCAD","EURCHF",
                      "GBPCHF","CHFJPY","NZDCHF","USDCHF","EURGBP","EURJPY","EURNZD",
                      "EURUSD","GBPJPY","GBPNZD","GBPUSD","NZDJPY","USDJPY","NZDUSD"};
double cor[28][28];
double Macd[];
int pair1,pair2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Macd);

   ObjectCreate ("P1", OBJ_LABEL, 0, 0, 0);// ???????? ???.
   ObjectSet    ("P1", OBJPROP_XDISTANCE, 10);      
   ObjectSet    ("P1", OBJPROP_YDISTANCE, 55);
   ObjectSet    ("P1", OBJPROP_CORNER, 0); //????_??????_???????
   ObjectCreate ("P2", OBJ_LABEL, 0, 0, 0);// ???????? ???.
   ObjectSet    ("P2", OBJPROP_XDISTANCE, 10);      
   ObjectSet    ("P2", OBJPROP_YDISTANCE, 105);
   ObjectSet    ("P2", OBJPROP_CORNER, 0); //????_??????_???????
   ObjectCreate ("VAL", OBJ_LABEL, 0, 0, 0);// ???????? ???.
   ObjectSet    ("VAL", OBJPROP_XDISTANCE, 10);      
   ObjectSet    ("VAL", OBJPROP_YDISTANCE, 155);
   ObjectSet    ("VAL", OBJPROP_CORNER, 0); //????_??????_???????
  for(int i=0;i<28;i++)for(int j=0;j<28;j++)cor[i][j]=0;
  double cormax=0;
  for(i=0;i<28;i++)
    {
    for(j=0;j<28;j++)
      {
      if(i!=j)
        {
        for(int b=0;b<per;b++)
          {
          double macd_i=iMACD(sy[i],0,12,26,9,PRICE_OPEN,MODE_MAIN,b);
          double macd_j=iMACD(sy[j],0,12,26,9,PRICE_OPEN,MODE_MAIN,b);
          if(macd_i>0&&macd_j>0)cor[i][j]=cor[i][j]+1;
          if(macd_i<0&&macd_j<0)cor[i][j]=cor[i][j]+1;
          if(macd_i>0&&macd_j<0)cor[i][j]=cor[i][j]-1;
          if(macd_i<0&&macd_j>0)cor[i][j]=cor[i][j]-1;
          }
        cor[i][j]=cor[i][j]/per;
        if(MathAbs(cor[i][j])>MathAbs(cormax)){cormax=cor[i][j];pair1=i;pair2=j;}
        ObjectSetText("P1",sy[pair1],33,"Arial",Yellow); 
        ObjectSetText("P2",sy[pair2],33,"Arial",Green); 
        ObjectSetText("VAL",DoubleToStr(cor[pair1][pair2],6),33,"Arial",Blue); 
        }
      }
    }    
  

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  ObjectDelete("P1");
  ObjectDelete("P2");
  ObjectDelete("VAL");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  for(int b=0;b<per;b++)Macd[b]=(k1*iMACD(sy[pair1],0,12,26,9,PRICE_OPEN,MODE_MAIN,b))-(k2*iMACD(sy[pair2],0,12,26,9,PRICE_OPEN,MODE_MAIN,b));
  return(0);
  }
//+------------------------------------------------------------------+